Summary: Linux Kernel 2.2.19
Name: kernel
%define sublevel 19
%define kversion 2.2.%{sublevel}
%define ksymoopsver 2.3.5
Version: %{kversion}
Release: 1.0.30
Copyright: GPL
Group: System Environment/Kernel 

Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.2/linux-2.2.19.tar.gz
Source1: ftp://ftp.kernel.org/pub/linux/utils/kernel/ksymoops/v2.3/ksymoops-%{ksymoopsver}.tar.gz

### Sources 10 - 19 are i686 .config's
Source10: kernel-2.2.19-i686.config
Source11: kernel-2.2.19-i686-lids-mods.config
Source12: kernel-2.2.19-i686-smp-mods.config
Source13: kernel-2.2.19-i686-smp-lids-mods.config
Source14: kernel-2.2.19-i686-BOOT.config

### Sources 20 - 29 are i386 .config's
Source20: kernel-2.2.19-i386.config
Source21: kernel-2.2.19-i386-lids-mods.config
Source22: kernel-2.2.19-i386-smp-mods.config
Source23: kernel-2.2.19-i386-smp-lids-mods.config
Source24: kernel-2.2.19-i386-BOOT.config

###  Our kernel upgrade helper.
Source30: kernel-upgrade-script-%{release}


# ingo's RAID 0.90 patch
Patch0: raid-2.2.19-A0

# OpenWall/LIDS patch
Patch1: linux-2.2.19-ow1-lids0.9.15-raidfixed.patch

# Other stuff.
Patch3: linux-2.2.16-ksym-version.patch
Patch4: ksymoops-2.3.5-mandir.patch

# Security or update-related patches
Patch30: linux-2.2.19-ptrace-and-symlink-security-gd.diff
Patch31: linux-2.2.19-syncookie-fix-from-2.2.20-12.diff
Patch32: linux-2.2.19-lids-0.11.pre2-exec-and-sched-fixes-2.diff
Patch33: linux-2.2.19-lids-0.11.pre2-exec-and-sched-fixes-fixes-1.diff
Patch34: linux-2.2.19-zlib-doublefree-gd-1.diff
Patch35: linux-2.2.19-lcall-gd-1.diff
Patch36: linux-2.2.19-22rc1_security_backport-gd-1.diff
Patch37: linux-2.2.20-22_more_security_backport-gd-1.diff
Patch38: linux-2.2.20-owl1-fixes-gd-1.diff
Patch39: linux-2.2.20-SFBID_6115-gd-1.diff
Patch40: linux-2.2.20-rc5-merge-with-sec-fixes-1.0.1-gd-1.diff
Patch41: linux-2.2.20-esl-CAN-2003-0127-fix-gd-2.diff


Requires: initscripts >= 6.0, lids-base >= 0.9.15-1.0.25
Buildroot: /var/tmp/%{name}-root
ExclusiveArch: i386 i586 i686
ExclusiveOS: Linux

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Red Hat Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.


%package source
Requires: kernel-headers = %{kversion}
Summary: The source code for the Linux kernel.
Group: Development/System

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned
to your particular hardware, if you are so inclined (and you know what
you're doing).


%package utils
Summary: Kernel related utilities, mostly ksymoops for submitting bug reports.
Group: System Environment/Kernel

%description utils
The kernel-utils package contains ksymoops, a utility that can be used
for decrypting the kernel's OOPS output.


%package headers
Summary: Header files for the Linux kernel.
Group: Development/System

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
kernel.


%package doc
Summary: Various documentation for the Linux kernel
Group: Documentation

%description doc
This package contains documentation files form the kernel
source. Various bits of information about the Linux kernel and the
device drivers shipped with it are documented in these files.

You'll want to install this package if you need a reference to the
options that can be passed to Linux kernel modules at load time.


%package lids-mods
Summary:  The Linux kernel with moduels
Group: System Environment/Kernel
Provides: kernel = %{version}

%description lids-mods
This is a standard 2.2.19 kernel compiled with modules for the
EnGarde Secure Linux distribution.


%package smp-mods
Summary:  The Linux kernel with moduels
Group: System Environment/Kernel
Provides: kernel = %{version}

%description smp-mods
This is a standard 2.2.19 kernel compiled with modules for the
EnGarde Secure Linux distribution.


%package smp-lids-mods
Summary:  The Linux kernel with moduels
Group: System Environment/Kernel
Provides: kernel = %{version}

%description smp-lids-mods
This is a standard 2.2.19 kernel compiled with modules for the
EnGarde Secure Linux distribution.


%package BOOT
Summary: The linux kernel compiled for the EnGarde Boot CD
Group: System Environment/Kernel
Provides: Kernel = %{version}

%description BOOT
This kernel is compiled specifically for the Engarde Boot CD.  This
kernel includes network and scsi support via modules.  Do not use this
kernel as your EnGarde systems primary kernel.


%prep
%setup -q -n linux -a 1 
%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1

mkdir configs
cp -fv $RPM_SOURCE_DIR/kernel-%{version}-i[36]86*.config configs

### BUILD
#
%build

if [ -x /usr/bin/getconf ] ; then
    NRPROC=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $NRPROC -eq 0 ] ; then
        NRPROC=1
    fi
else
    NRPROC=1
fi

BuildKernel() {
    if [ -n "$1" ] ; then
        Config=%{_target_cpu}-$1
        KernelVer=%{version}-%{release}-$1
    else
	Config=%{_target_cpu}
	KernelVer=%{version}-%{release}
    fi

    echo "- ------> kernel-%{kversion}-$Config.confg <----------"

    rm -f .config
    cp $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config ./arch/i386/defconfig

    ### Only append $1 if we have one.
    if [ -n "$1" ] ; then
    	perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}-$1/" Makefile
    else
	perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}/" Makefile
    fi

    make mrproper
    make oldconfig
    make -j dep
    make include/linux/version.h
    make -j $NRPROC bzImage MAKE="make -j $NRPROC"

    mkdir -p $RPM_BUILD_ROOT/boot
    install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
    cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
    cp vmlinux $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer

}

BuildMods() {
   make -j $NRPROC modules

   find include/linux/modules -size 0 | while read file ; do \
        echo > $file
   done

   mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/{block,cdrom,fs,ipv4,misc,net,scsi,video}
   make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer


}

SaveHeaders() {
    if [ -n "$1" ] ; then
        echo "SAVING HEADERS for $1"
    fi
    # deal with the kernel headers that are version specific
    mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux
    if [ -n "$1" ] ; then
        install -m 644 include/linux/autoconf.h \
            $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux/autoconf-$1.h
        install -m 644 include/linux/version.h \
            $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux/version-$1.h
    fi
}

[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

BuildKernel 
BuildMods 
SaveHeaders 

BuildKernel lids-mods
BuildMods lids-mods
SaveHeaders lids-mods

BuildKernel smp-mods
BuildMods smp-mods
SaveHeaders smp-mods

BuildKernel smp-lids-mods
BuildMods smp-lids-mods
SaveHeaders smp-lids-mods

BuildKernel BOOT
BuildMods BOOT
SaveHeaders BOOT

### build ksymoops
make -C ksymoops-%{ksymoopsver}


### do this for upgrades...in case the old modules get removed we have
### loopback in the kernel so that mkinitrd will work.
%pre
  /sbin/modprobe loop 2> /dev/null > /dev/null
  exit 0


%install

mkdir -p $RPM_BUILD_ROOT/{boot,sbin}

mkdir -p $RPM_BUILD_ROOT/usr/include
ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

> $RPM_BUILD_ROOT/boot/kernel.h-%{kversion}

make mrproper
mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
tar cf - . | tar xf - -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

make install -C ksymoops-%{ksymoopsver} INSTALL_PREFIX=$RPM_BUILD_ROOT/usr \
	INSTALL_MANDIR=$RPM_BUILD_ROOT/%{_mandir}/man8

  ###  Install our -Uvh helper.
  install -m400 %{SOURCE30} $RPM_BUILD_ROOT/boot/kernel-upgrade-script


%post
  cd /boot
  ln -sf vmlinuz-%{kversion}-%{release} vmlinuz
  ln -sf System.map-%{kversion}-%{release} System.map

  perl -w /boot/kernel-upgrade-script -r NORMAL

%post lids-mods
  perl -w /boot/kernel-upgrade-script -r lids-mods

%post smp-mods
  perl -w /boot/kernel-upgrade-script -r smp-mods

%post smp-lids-mods
  perl -w /boot/kernel-upgrade-script -r smp-lids-mods


%clean
rm -rf $RPM_BUILD_ROOT


%post headers
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux
cd /usr/include
rm -f linux asm
ln -snf ../src/linux/include/linux linux
ln -snf ../src/linux/include/asm asm
cd /boot
rm -f kernel.h kernel.h-%{kversion}
ln -snf /usr/src/linux/include/linux/kernel.h-%{kversion} kernel.h-%{kversion}
exit 0

### POST SOURCE
#
%post source
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux

### POSTUN HEADERS
#
%postun headers
if [ -L /usr/src/linux ]; then
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
        [ $1 = 0 ] && rm -f /usr/src/linux /usr/include/linux /usr/include/asm /boot/kernel.h /boot/kernel.h-%{kversion}
    fi
fi
exit 0

### POSTUN SOURCE
#
if [ -L /usr/src/linux ]; then
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
        [ $1 = 0 ] && rm -f /usr/src/linux
    fi
fi

#
### FILES
#
%files
%attr(400,root,root)	/boot/kernel-upgrade-script
%defattr(-,root,root)
/boot/vmlinux-%{kversion}-%{release}
/boot/vmlinuz-%{kversion}-%{release}
/boot/System.map-%{kversion}-%{release}
/lib/modules/%{kversion}-%{release}/block
/lib/modules/%{kversion}-%{release}/cdrom
/lib/modules/%{kversion}-%{release}/fs
/lib/modules/%{kversion}-%{release}/ipv4
/lib/modules/%{kversion}-%{release}/misc
/lib/modules/%{kversion}-%{release}/net
/lib/modules/%{kversion}-%{release}/scsi
/lib/modules/%{kversion}-%{release}/video


%files lids-mods
%defattr(-,root,root)
/boot/vmlinux-%{kversion}-%{release}-lids-mods
/boot/vmlinuz-%{kversion}-%{release}-lids-mods
/boot/System.map-%{kversion}-%{release}-lids-mods
/lib/modules/%{kversion}-%{release}-lids-mods/block
/lib/modules/%{kversion}-%{release}-lids-mods/cdrom
/lib/modules/%{kversion}-%{release}-lids-mods/fs
/lib/modules/%{kversion}-%{release}-lids-mods/ipv4
/lib/modules/%{kversion}-%{release}-lids-mods/misc
/lib/modules/%{kversion}-%{release}-lids-mods/net
/lib/modules/%{kversion}-%{release}-lids-mods/scsi
/lib/modules/%{kversion}-%{release}-lids-mods/video

%files smp-mods
%defattr(-,root,root)
/boot/vmlinux-%{kversion}-%{release}-smp-mods
/boot/vmlinuz-%{kversion}-%{release}-smp-mods
/boot/System.map-%{kversion}-%{release}-smp-mods
/lib/modules/%{kversion}-%{release}-smp-mods/block
/lib/modules/%{kversion}-%{release}-smp-mods/cdrom
/lib/modules/%{kversion}-%{release}-smp-mods/fs
/lib/modules/%{kversion}-%{release}-smp-mods/ipv4
/lib/modules/%{kversion}-%{release}-smp-mods/misc
/lib/modules/%{kversion}-%{release}-smp-mods/net
/lib/modules/%{kversion}-%{release}-smp-mods/scsi
/lib/modules/%{kversion}-%{release}-smp-mods/video

%files smp-lids-mods
%defattr(-,root,root)
/boot/vmlinux-%{kversion}-%{release}-smp-lids-mods
/boot/vmlinuz-%{kversion}-%{release}-smp-lids-mods
/boot/System.map-%{kversion}-%{release}-smp-lids-mods
/lib/modules/%{kversion}-%{release}-smp-lids-mods/block
/lib/modules/%{kversion}-%{release}-smp-lids-mods/cdrom
/lib/modules/%{kversion}-%{release}-smp-lids-mods/fs
/lib/modules/%{kversion}-%{release}-smp-lids-mods/ipv4
/lib/modules/%{kversion}-%{release}-smp-lids-mods/misc
/lib/modules/%{kversion}-%{release}-smp-lids-mods/net
/lib/modules/%{kversion}-%{release}-smp-lids-mods/scsi
/lib/modules/%{kversion}-%{release}-smp-lids-mods/video

%files BOOT
%defattr(-,root,root)
/boot/vmlinux-%{kversion}-%{release}-BOOT
/boot/vmlinuz-%{kversion}-%{release}-BOOT
/boot/System.map-%{kversion}-%{release}-BOOT
/lib/modules/%{kversion}-%{release}-BOOT/block
/lib/modules/%{kversion}-%{release}-BOOT/cdrom
/lib/modules/%{kversion}-%{release}-BOOT/fs
/lib/modules/%{kversion}-%{release}-BOOT/ipv4
/lib/modules/%{kversion}-%{release}-BOOT/misc
/lib/modules/%{kversion}-%{release}-BOOT/net
/lib/modules/%{kversion}-%{release}-BOOT/scsi
/lib/modules/%{kversion}-%{release}-BOOT/video


%files source
%defattr(-,root,root)
/usr/src/linux-%{kversion}/COPYING
/usr/src/linux-%{kversion}/CREDITS
/usr/src/linux-%{kversion}/Documentation
/usr/src/linux-%{kversion}/MAINTAINERS
/usr/src/linux-%{kversion}/Makefile
/usr/src/linux-%{kversion}/README
/usr/src/linux-%{kversion}/REPORTING-BUGS
/usr/src/linux-%{kversion}/Rules.make
/usr/src/linux-%{kversion}/arch/i386
/usr/src/linux-%{kversion}/drivers
/usr/src/linux-%{kversion}/fs
/usr/src/linux-%{kversion}/init
/usr/src/linux-%{kversion}/ipc
/usr/src/linux-%{kversion}/kernel
/usr/src/linux-%{kversion}/lib
/usr/src/linux-%{kversion}/mm
## /usr/src/linux-%{kversion}/modules
/usr/src/linux-%{kversion}/net
## /usr/src/linux-%{kversion}/scripts

%files headers
%defattr(-,root,root)
%dir /usr/src/linux-%{kversion}
/usr/src/linux-%{kversion}/configs
/usr/src/linux-%{kversion}/include/asm-i386
## /usr/src/linux-%{kversion}/include/asm
/usr/src/linux-%{kversion}/include/asm-generic
/usr/src/linux-%{kversion}/include/linux
/usr/src/linux-%{kversion}/include/net
/usr/src/linux-%{kversion}/include/scsi
/usr/src/linux-%{kversion}/include/video
/boot/kernel.h-%{kversion}

%files doc
%defattr(-,root,root)
%doc Documentation/*

### CHANGELOG
#
%changelog
* Thu Mar 13 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.30
  - Backport ethernet padding fixes and proc/mmap fixes from 2.2.24-rc5.
  - [CAN-2003-0127] Merge fix for kmod/ptrace() issue as reported by Andrzej
    Szombierski.  Thanks to Seth Arnold from Immunix for the patch.

* Mon Nov 18 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.29
  - Fix previous changelog entry (I did the fixes, not Dave).
  - Merge more security fixes from 2.2.22-FINAL (Patch #37).
  - Merge more security fixes from 2.2.22-owl1 (Patch #38).
  - Fix DoS (SF BugID #6115) (Patch #39).
  - Updated kernel-upgrade-script.

* Mon Oct 21 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.28
  - Backport some security updates from 2.2.22-rc1 (patch #212).
  - Updated kernel-upgrade-script.

* Fri Feb 8 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.2[567]
  - Fix zlib double free in drivers/net/zlib.c (Patch #34)
  - Add Solar's version of lcall fix. (Patch #35)
  - Updated kernel-upgrade-script.

* Wed Jan 09 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.2[234]
  - LIDS vulnerabilities (Patch #32/#33).  From Phil's changelog:
    - fs/exec.c: BIG SECURITY FIX! prevent the use of LD_* environment
                 variables if CAP_SYS_PTRACE is off
    - sched.h: SECURITY FIX! drop non needed capabilities fro process
               launched before sealing LIDS
  - Updated kernel-upgrade-script to 1.8 (with small changes).
  - Reqiure lids-base >= 0.9.15-1.0.25.


* Mon Nov 05 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.21
  - Well here we are again boys and girls.  This update fixes the
    syncookie bug.  This ties the syncookie in with a port so you
    can't exaust them as easily.  Backported from 2.2.20-pre12.
  - Updated kernel-upgrade-script to version 1.7.


* Thu Oct 11 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.20
  - (Note:  I made this .20 because there are other various
     kernels floating about.  Please don't make any kernels
     with a release greater then this one unless they're
     intended for an update.)

  - Some security updates:
    - Disallow ptracing of all SUID/GID processes (Solar's patch).
    - Fix local DoS in symlink following code (Solar's patch).
    - While I was at it, integrated patch from Solar to fix dumpable
        races on sparc64.

  - Some package updates:
    - New source file:  kernel-upgrade-script.  Look at the code to
        see what it does.  In a nutshell, it removes/recreates
        symlinks and does some /etc/lilo.conf magic.
    - Run this new script in the %post for all four "real" kernel
        sub-packages ("normal", lids-mods, smp-mods, and smp-lids-mods).
    - The current version of this script, as of packaging, is 1.5.


* Thu Apr 12 2001 Nicholas DeClario <nick@guardiandigital.com>
- Added additional NIC card and SCSI card support to all 
  i386 kernels (1.0.9)
  
* Thu Mar 29 2001 Nicholas DeClario <nick@guardiandigital.com> 
- Fixed module problem with base kernel (1.0.5)

* Wed Mar 28 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.4
  - Fixed a stupid typo in the EXTRARELEASE perl expression.


* Wed Mar 28 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.19, Release 1.0.3
  - Updated to version 2.2.19 and merged some patches.


* Tue Mar 20 2001 Nick DeClario <nick@guardiandigital.com>
- created spec file based on Lockbox kernel RPM 
